﻿#include Base64.ahk
; advapi32.dll handle
; Returned from _MD5_Startup()
; Required in _MD5_Shutdown()
$advapi32_h_DLL := 0

;===============================================================================
; Function Name:    _MD5_Startup()
; Description:      Load advapi32.dll
; Requirement(s):   Valid Path to advapi32.dll in $advapi32_h_DLL
; Parameter(s):     None
; Return Value(s):  On Success - 0
;                   On Failure - ErrorLevel
;===============================================================================
_MD5_Startup()
{
   Global $advapi32_h_DLL
   $advapi32_h_DLL := DllCall("LoadLibrary", "str", "advapi32.dll")

   If (ErrorLevel <> 0)
   {
      Return ErrorLevel
   }
  
   Return 0
}
;===============================================================================
; Function Name:    _MD5_Shutdown()
; Description:      Unloads advapi32.dll
; Requirement(s):   Valid Path to advapi32.dll in $advapi32_h_DLL
; Parameter(s):     None
; Return Value(s):  On Success - 0
;                   On Failure - ErrorLevel
;===============================================================================
_MD5_Shutdown()
{
   Global $advapi32_h_DLL
   DllCall("FreeLibrary", "UInt", $advapi32_h_DLL)
   
   If (ErrorLevel <> 0)
   {
      Return ErrorLevel
   }
  
   $advapi32_h_DLL := 0
   Return 0
}

;;;--- Generate MD5 via Win32API
MD5(ByRef sData, nLen) {
   DllCall("advapi32\CryptAcquireContextA", "UIntP",hProv, "UInt",0, "UInt",0, "UInt",1, "UInt",0xF0000000)
   DllCall("advapi32\CryptCreateHash", "UInt",hProv, "UInt",0x8000|0|3, "UInt",0, "UInt",0, "UIntP", hHash)  ; SID = 3: MD5, 4: SHA1

   DllCall("advapi32\CryptHashData", "UInt",hHash, "UInt",&sData, "UInt",nLen, "UInt",0)

   DllCall("advapi32\CryptGetHashParam", "UInt",hHash, "UInt",2, "UInt",0, "UIntP",nSize, "UInt",0)
   VarSetCapacity(HashVal, nSize, 0)
   DllCall("advapi32\CryptGetHashParam", "UInt",hHash, "UInt",2, "UInt",&HashVal, "UIntP",nSize, "UInt",0)

   DllCall("advapi32\CryptDestroyHash", "UInt",hHash)
   DllCall("advapi32\CryptReleaseContext", "UInt",hProv, "UInt",0)

   Loop %nSize%
      sHash .= SubStr( Hex( *(&HashVal+A_Index-1) + 0x100 ), -1)

   ;; Free Memory
   HashVal=

   Return sHash
}

;;;--- Generate MD5-Base64
MD5_Base64(ByRef Buf, L) {                                                   ; Binary buffer, Length in bytes
  ; Get MD5 Hash in Base64
  Return Substr(Base64EncodeHexStr(MD5(Buf, L)), 1, 22)
}
