﻿;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;
;; Sub-Routine to gen SiteList
;;;;;;;;;;;;;;;;;;
SQLgenSitelist:
$sSQL =
( 
   select distinct domain,
          sum(case type when 'B' then 1 else 0 end) bl,
          sum(case type when 'W' then 1 else 0 end) wl
   from tmp
   where type in ('B','W')
   and   item <> ''
   group by domain
)
$iRC := _SQLite_GetTable($SQLITE_h_DB, $sSQL, $sResult, $iRows, $iCols, -1, 4096)
If ($iRC <> $SQLITE_OK)
{
   MsgBox SQLite GetTable ERROR: %$iRC% - %$SQLITE_s_ERROR%
   $iRC := _SQLite_CloseDB(-1)
   $iRC := _SQLite_ShutDown()
   GUIExit()
}

;;;;;;;;;;;;;;;;;;
;; <sp>
;;;;;;;;;;;;;;;;;;
$vSiteList=
(
<?xml version="1.0" encoding="utf-8"?>
<sp>
)
Loop, Parse, $sResult, `n
{
   If (A_Index > 1)
   {
      StringSplit, $Field, A_LoopField, |
      Domain:=$Field1
      BL:=$Field2
      WL:=$Field3
      
;;;;;;;;;;;;;;;;;;
;; <m2filter d=domain
;;;;;;;;;;;;;;;;;;
$vSiteList=
(
%$vSiteList%
	<m2filter d="%Domain%" version="1.0">
)

;;;;;;;;;;;;;;;;;;
;; <blacklist....item
;;;;;;;;;;;;;;;;;;
      $Working=B
      If BL > 0
      {
         GoSub SQLGetItem
      }
      Else
      {
$vSiteList=
(
%$vSiteList%<blacklist/>
)
      }

;;;;;;;;;;;;;;;;;;
;; <whitelist....item
;;;;;;;;;;;;;;;;;;
      $Working=W
      If WL > 0
      {
         GoSub SQLGetItem
      }
      Else
      {
$vSiteList=
(
%$vSiteList%<whitelist/>
)
      }

;;;;;;;;;;;;;;;;;;
;; </m2filter>
;;;;;;;;;;;;;;;;;;
$vSiteList=
(
%$vSiteList%</m2filter>
)

   }
}

;;;;;;;;;;;;;;;;;;
;; </sp>
;;;;;;;;;;;;;;;;;;
$vSiteList=
(
%$vSiteList%
</sp>
)

FileDelete SiteList.XML\SiteList.xml
FileAppend %$vSiteList%, SiteList.XML\SiteList.xml
Return

;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;
;; Sub-Routine to retrieve blacklist/whitelist item
;;;;;;;;;;;;;;;;;;
SQLGetItem:
$sSQL =
( 
   select distinct '<item mode="' || regex || '" name="' || 
         ifnull((select min(filtername)
            from nsitelist n
           where n.type = tmp.type     
             and n.domain = tmp.domain       
             and n.regex = tmp.regex       
             and n.item = tmp.item), '') || '/' ||
         ifnull((select txt
            from nsitelist n
           where n.type = tmp.type     
             and n.domain = tmp.domain       
             and n.regex = tmp.regex       
             and n.item = tmp.item
             and n.filtername =(select min(x.filtername)
                                  from nsitelist x
                                 where x.type = n.type     
                                   and x.domain = n.domain       
                                   and x.regex = n.regex       
                                   and x.item = n.item)), '') ||         
          '">' || item || '</item>' rule
   from tmp
   where type = '%$Working%'
   and   domain = '%DOMAIN%'
   and   item <> ''
   order by regex, item;
)
$iRC := _SQLite_GetTable(-1, $sSQL, $sResult, $iRows, $iCols) ;, -1, 4096)
If ($iRC <> $SQLITE_OK)
{
   MsgBox SQLite GetTable ERROR: %$iRC% - %$SQLITE_s_ERROR%
   $iRC := _SQLite_CloseDB(-1)
   $iRC := _SQLite_ShutDown()
   GUIExit()
}

If $Working=B
{
$vSiteList=
(
%$vSiteList%<blacklist>
)
}
else
{
$vSiteList=
(
%$vSiteList%<whitelist>
)
}

;$vSiteListx := RegExReplace($sResult, "^[^\n]*[\n]")
;$vSiteListx := RegExReplace($vSiteListx, "\n")
;$vSiteList=%$vSiteList%%$vSiteListx%
;$vSiteListx =

Loop, Parse, $sResult, `n
If (A_Index > 1)
{
$vSiteList=
(
%$vSiteList%%A_LoopField%
)
}

If $Working=B
{
$vSiteList=
(
%$vSiteList%</blacklist>
)
}
else
{
$vSiteList=
(
%$vSiteList%</whitelist>
)
}

Return
